Coin: SoSurroundScale Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoSurroundScale Class Reference
Node Classes

The SoSurroundScale class is used to automatically scale geometry to surround other geometry. More...

`#include <Inventor/nodes/SoSurroundScale.h>`

Inheritance diagram for SoSurroundScale:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoSurroundScale (void)
void | invalidate (void)
virtual void | doAction (SoAction *action)
void | setDoingTranslations (const SbBool val)
SbBool | isDoingTranslations (void)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoTransformation
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFInt32 | numNodesUpToContainer
SoSFInt32 | numNodesUpToReset

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoSurroundScale ()
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | pick (SoPickAction *action)
void | updateMySurroundParams (SoAction *action, const SbMatrix &inv)
void | setIgnoreInBbox (const SbBool val)
SbBool | isIgnoreInBbox (void)
Protected Member Functions inherited from SoTransformation
| SoTransformation (void)
virtual | ~SoTransformation ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoTransformation
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes
SbVec3f | cachedScale
SbVec3f | cachedInvScale
SbVec3f | cachedTranslation
SbBool | cacheOK
SbBool | doTranslations
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoSurroundScale class is used to automatically scale geometry to surround other geometry.

This node calculates a transformation (a translation and a scale) which will, when the node is traversed, be appended to the current model matrix, making a default cube placed directly to the right of this node in the graph surround geometry to the right of the container branch this node is on. The container is specified by the field SoSurroundScale::numNodesUpToContainer.

When calculating the bounding box to be surrounded, the bounding box action will be applied to the container node, and the bounding box calculations will be reset after traversing the node specified by the field SoSurroundScale::numNodesUpToReset.

A way of thinking of the container node is that there exists a path from the root-node to the SoSurroundScale node. This path has a number of nodes in it. numNodesUpToContainer is the number of nodes in the path from the SoSurroundScale node towards the root node. When having counted numNodesUpToContainer from the SoSurroundScale node, you will have reached the container node. The container node is the seed-node that the bounding box is calculated from. All nodes lower than the seed-node will be a part of the bounding box unless they are closer to the SoSurroundScale node than numNodesUpToReset.

To make sure the node(s) that are to be scaled by the SoSurroundScale node aren't a part of the bounding box, the numNodesUpToReset is used. It is also the number of nodes up from the SoSurroundScale node towards the root node. The meaning of numNodesUpToReset is that nodes that are closer to the SoSurroundNode than the node at position numNodesUpToReset are not to be used for bounding box calculations.

Here's a complete, standalone example which sets up an SoTrackballDragger (connected to a cube), and uses an SoSurroundScale node to make it auto-scale to the size of the high cube and translates it an offset to one side of the cube:

#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/draggers/SoTrackballDragger.h>
#include <Inventor/nodes/SoAntiSquish.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoSurroundScale.h>
#include <Inventor/nodes/SoRotation.h>
#include <Inventor/nodes/SoTranslation.h>
int
main(int argc, char **argv)
{
QWidget * window = SoQt::init(argv[0]);
if (window == NULL) exit(1);
SoSeparator * root = new SoSeparator;
root->ref();
SoSeparator * surroundsep = new SoSeparator;
root->addChild(surroundsep);
SoTranslation * translation = new SoTranslation;
translation->translation = SbVec3f(12, 0, 0);
surroundsep->addChild(translation);
SoSurroundScale * ss = new SoSurroundScale;
ss->numNodesUpToReset = 1;
ss->numNodesUpToContainer = 2;
surroundsep->addChild(ss);
SoAntiSquish * antisquish = new SoAntiSquish;
antisquish->sizing = SoAntiSquish::BIGGEST_DIMENSION;
surroundsep->addChild(antisquish);
SoTrackballDragger * dragger = new SoTrackballDragger;
surroundsep->addChild(dragger);
SoRotation * rotation = new SoRotation;
rotation->rotation.connectFrom(& dragger->rotation);
root->addChild(rotation);
SoCube * cube = new SoCube;
cube->height = 10.0f;
root->addChild(cube);
SoQtExaminerViewer * viewer = new SoQtExaminerViewer(window);
viewer->setSceneGraph(root);
viewer->setViewing(FALSE);
viewer->setDecoration(FALSE);
viewer->show();
SoQt::show(window);
SoQt::mainLoop();
delete viewer;
root->unref();
return 0;
}
SbVec3f
The SbVec3f class is a 3 dimensional vector with floating point coordinates.
Definition SbVec3f.h:51
SoAntiSquish
The SoAntiSquish class is used to reset to uniform scaling.
Definition SoAntiSquish.h:42
SoAntiSquish::sizing
SoSFEnum sizing
Definition SoAntiSquish.h:56
SoAntiSquish::BIGGEST_DIMENSION
@ BIGGEST_DIMENSION
Definition SoAntiSquish.h:52
SoBase::unref
void unref(void) const
Definition SoBase.cpp:530
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoCube
The SoCube class is for rendering cubes.
Definition SoCube.h:42
SoCube::height
SoSFFloat height
Definition SoCube.h:52
SoField::connectFrom
SbBool connectFrom(SoEngineOutput *master, SbBool notnotify=FALSE, SbBool append=FALSE)
Definition SoField.cpp:929
SoGroup::addChild
virtual void addChild(SoNode *node)
Definition SoGroup.cpp:453
SoRotation
The SoRotation class specifies a rotation transformation.
Definition SoRotation.h:40
SoRotation::rotation
SoSFRotation rotation
Definition SoRotation.h:49
SoSeparator
The SoSeparator class is a state-preserving group node.
Definition SoSeparator.h:44
SoSurroundScale::numNodesUpToContainer
SoSFInt32 numNodesUpToContainer
Definition SoSurroundScale.h:52
SoSurroundScale::SoSurroundScale
SoSurroundScale(void)
Definition SoSurroundScale.cpp:250
SoSurroundScale::numNodesUpToReset
SoSFInt32 numNodesUpToReset
Definition SoSurroundScale.h:53
SoTrackballDragger
The SoTrackballDragger provides the end-user with rotation and scaling interaction possibilities.
Definition SoTrackballDragger.h:51
SoTrackballDragger::rotation
SoSFRotation rotation
Definition SoTrackballDragger.h:81
SoTranslation
The SoTranslation class is a node type for specifying geometry translations.
Definition SoTranslation.h:40
SoTranslation::translation
SoSFVec3f translation
Definition SoTranslation.h:49

It might be easier to see how the SoSurroundScale node works in the above example by looking at the actual scene graph:

#Inventor V2.1 ascii
Separator {
Separator {
Translation {
translation 12 0 0
}
SurroundScale {
numNodesUpToContainer 2
numNodesUpToReset 1
}
AntiSquish {
sizing BIGGEST_DIMENSION
}
DEF mydragger TrackballDragger {
}
}
Rotation {
rotation 0 0 1 0 =
USE mydragger . rotation
}
Cube {
height 10
}
}

This node is internally used by manipulators to make it possible for them to scale their dragger's geometry to match the scene graph geometry it is modifying, as is demonstrated above (but outside of the context of a manipulator).

It is also generally useful for application programmers who want any particular piece of geometry surround other geometry of unknown or changing extent.

SoSurroundScale nodes in the scene graph are often paired up with SoAntiSquish nodes to get uniform scaling along all three principal axes, as has also been done in the above example.

FILE FORMAT/DEFAULTS:

SurroundScale {
numNodesUpToContainer 0
numNodesUpToReset 0
}

See also
  SoAntiSquish

## Constructor & Destructor Documentation

## ◆ SoSurroundScale()

SoSurroundScale::SoSurroundScale | ( | void |  | ) |

Constructor.

## ◆ ~SoSurroundScale()

SoSurroundScale::~SoSurroundScale | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoSurroundScale::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoSurroundScale::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoTransformation.

## ◆ getFieldDataPtr()

const SoFieldData ** SoSurroundScale::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoSurroundScale::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoTransformation.

## ◆ invalidate()

void SoSurroundScale::invalidate | ( | void |  | ) |

Invalidates the cached transformation, forcing a recalculation to be done the next time this node is traversed.

## ◆ doAction()

void SoSurroundScale::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## ◆ setDoingTranslations()

void SoSurroundScale::setDoingTranslations | ( | const SbBool | val | ) |

Sets whether the translation part of the transformation should be ignored or not. Default behavior is to translate.

## ◆ isDoingTranslations()

SbBool SoSurroundScale::isDoingTranslations | ( | void |  | ) |

Returns whether the translation part of the transformation should be ignored or not.

See also
  setDoingTranslations()

## ◆ callback()

void SoSurroundScale::callback | ( | SoCallbackAction * | action | ) |
| protectedvirtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## ◆ GLRender()

void SoSurroundScale::GLRender | ( | SoGLRenderAction * | action | ) |
| protectedvirtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## ◆ getBoundingBox()

void SoSurroundScale::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |
| protectedvirtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

## ◆ getMatrix()

void SoSurroundScale::getMatrix | ( | SoGetMatrixAction * | action | ) |
| protectedvirtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

## ◆ pick()

void SoSurroundScale::pick | ( | SoPickAction * | action | ) |
| protectedvirtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

## ◆ updateMySurroundParams()

void SoSurroundScale::updateMySurroundParams | ( | SoAction * | action,
|  | const SbMatrix & | inv )
| protected

Calculates the translation and scale needed to make a default cube surround geometry to the right of the branch this node is on.

## ◆ setIgnoreInBbox()

void SoSurroundScale::setIgnoreInBbox | ( | const SbBool | val | ) |
| protected

Sets whether bounding box calculations in SoGetBoundingBoxAction should be affected by this node.

Default is to ignore our bounding box calculations.

## ◆ isIgnoreInBbox()

SbBool SoSurroundScale::isIgnoreInBbox | ( | void |  | ) |
| protected

Returns the value of the flag that decides whether bounding box calculations in SoGetBoundingBoxAction should be affected by this node.

See also
  setIgnoreInBbox()

## Member Data Documentation

## ◆ numNodesUpToContainer

SoSFInt32 SoSurroundScale::numNodesUpToContainer

Number of nodes in the path counting from this and "upwards" to the container node.

## ◆ numNodesUpToReset

SoSFInt32 SoSurroundScale::numNodesUpToReset

Number of nodes in the path counting from this and "upwards" to the node where we will reset the bounding box value.

## ◆ cachedScale

SbVec3f SoSurroundScale::cachedScale
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ cachedInvScale

SbVec3f SoSurroundScale::cachedInvScale
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ cachedTranslation

SbVec3f SoSurroundScale::cachedTranslation
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ cacheOK

SbBool SoSurroundScale::cacheOK
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ doTranslations

SbBool SoSurroundScale::doTranslations
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoSurroundScale.h
- SoSurroundScale.cpp